/* ---------------------------------------------------------- */
/*  pako_test.h                                               */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief    Pako SDL Game Library - Game apprication sample
@author   rerofumi
@since    Nov.05.2006
*/
/*-----------------------------------------------------
Copyright (C) 2006,2011 fumi2kick/rerofumi <rero2@yuumu.org>
All Rights Reserved.
-------------------------------------------------------
update
  Apr.09.2011 - Xe[g}VʂƂȂWIAppƂċLq
------------------------------------------------------*/

#ifndef PAKO_LASTERSHOOT_H
#define PAKO_LASTERSHOOT_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako/pako_opengl_app.h"

class PstmTop;

/**
* @brief Q[AvP[VTvNX
*        Q[{̕ApケɎR[hǉĂ
*
* @todo -
* @bug -
*/
class PakoLasterShoot : public PakoOpenglApp
{
    /* --- RXgN^EfXgN^ */
public:
    PakoLasterShoot();
    virtual  ~PakoLasterShoot();

	//! tXN[[h̐ݒ
	void setFullScreen(bool sw) { m_bFullScreen = sw; };
	//! TEhgƃobt@̐ݒ
	void setSoundQuality(int freq, int bufsize);

	//! JpAit[\tO̐ݒ
	void setDevelopDisp(bool sw) { m_bDevelopDisp = sw; };
	//! JpAit[\tO̐ݒ
	bool getDevelopDisp(void) { return(m_bDevelopDisp); };
	void setFramerateDisp(bool sw) { m_bFramerateDisp = sw; };
	bool getFramerateDisp(void)  { return(m_bFramerateDisp); };
    /* --- AvP[V\bh */
protected:
    int onBoot(void);
    int onExecuteBefore(void);
    int onExecuteAfter(void);
    bool tick(void);
    bool tickDisplay(void);

	//! true ŃXRȂɐit[\
	bool m_bDevelopDisp;
	//! true ŃXRȂɏԂ\
	bool m_bFramerateDisp;

    /* --- [J[N */
private:
    PstmTop *m_pStateMachine;
};

#endif
