/* ---------------------------------------------------------- */
/*  bulletmaker.h                                             */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief		e̐ƊǗA@pƓGp̃Cve[V
    @author		K.Kunikane (rerofumi)
    @since		Apr.16.2011
*/
/*-----------------------------------------------------
 Copyright (C) 2011 rero2@fumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#ifndef BULLETMAKER_H
#define BULLETMAKER_H

#include "pako/pako_opengl_app.h"
#include "bulletmanage.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/
class EnemyManage;

/**
 * @brief @̒eƊǗ
 *
 * @todo -
 * @bug -
 */
class MyBulletMaker : public BulletManage
{
public:
	MyBulletMaker() {};
	virtual ~MyBulletMaker(void) {};

	virtual void Init(PakoOpenglApp* pApp, int nSpriteLayer, int nSpriteNum);

	void doShot(int level, float pos_x, float pos_y);

	int CheckHit(EnemyManage* enemys);

	PakoOpenglApp *m_pApp;
	int  m_nSpriteLayer;
	int  m_nSpriteSize;

private:
	void request_level1(float x, float y);
	void request_level2(float x, float y);
	void request_level3(float x, float y);
};


/**
 * @brief G̒eƊǗ
 *
 * @todo -
 * @bug -
 */
class EnemyBulletMaker : public BulletManage
{
public:
	EnemyBulletMaker() {};
	virtual ~EnemyBulletMaker(void) {};

	virtual void Init(PakoOpenglApp* pApp, int nSpriteLayer, int nSpriteNum);

	PakoOpenglApp *m_pApp;
	int  m_nSpriteLayer;
	int  m_nSpriteSize;

	void doShot(int num, float aim, float fin, float speed, float pos_x, float pos_y);
};


/**
 * @brief p[AbvACëړǗ
 *
 * @todo -
 * @bug -
 */
class ItemMaker : public BulletManage
{
public:
	ItemMaker() {};
	virtual ~ItemMaker(void) {};

	virtual void Init(PakoOpenglApp* pApp, int nSpriteLayer, int nSpriteNum);

	void doShot(float pos_x, float pos_y);

	PakoOpenglApp *m_pApp;
	int  m_nSpriteLayer;
	int  m_nSpriteSize;
};

#endif
