/**
 * PAKO state machine
 * Q[CXe[g}l[W
 * ^CgʁAQ[{҂ƂAvP[V܂Ƃ߂
 */


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "ls_state_top.h"
#include "ls_state_title.h"
#include "ls_state_game.h"


/*-------------------------------*/
/* before/after                  */
/*-------------------------------*/

/* ------------------------- */
/* --- O */
void PstmTop::onBegin(void)
{
    PakoStateMachine* pState;

    /* --- ^CgfBN^[ */
    pState = new PstmTitle(getApp(), LS_STATE_TITLE_NAME);
    addSubState(pState);
    /* --- Q[fBN^[ */
    pState = new PstmGame(getApp(), LS_STATE_GAME_NAME);
    addSubState(pState);

    beginSubState(LS_STATE_TITLE_NAME);
}


/* ------------------------- */
/* --- ㏈ */
void PstmTop::onEnd(void)
{
    m_bExecute = false;
    m_strNextState = "";
}


/*-------------------------------*/
/* work                          */
/*-------------------------------*/

/* ------------------------- */
/* --- O */
void PstmTop::tick()
{
    /* --- ɃTuXe[gs */
    if (doSubState() == false) {
        onEnd();
    }
}


/* ------------------------- */
/* --- O */
void PstmTop::tickDisplay()
{
    doSubStateDisplay();
}
