/* ---------------------------------------------------------- */
/*  Pako_SpriteItem.h                                         */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - sprite item
    @author   rerofumi
    @since    Nov.05.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef PAKO_SPRITEITEM_H
#define PAKO_SPRITEITEM_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief XvCgǗNX
 *        XvCg11CX^X
 *
 * @todo -
 * @bug -
 */
class PakoSpriteItem
{
  /* ----------------------------------- */
  /* --- RXgN^EfXgN^ */
 public:
  PakoSpriteItem();
  PakoSpriteItem(const PakoSpriteItem& other);
  virtual  ~PakoSpriteItem();

  /* ----------------------------------- */
  /* --- pubNo */
 public:
  //! \ʒu(XvCg) X
  float m_PosX;
  //! \ʒu(XvCg) Y
  float m_PosY;
  //! \TCY
  int m_SizeW;
  //! \TCYc
  int m_SizeH;
  //! \[x(vCIeB)
  int m_Priority;
  //! l(1.0 ŕsA0.0 œ)
  float m_Blend;
  //! w\TCY傫菬
  float m_Zoom;
  //! eNX`W U
  int m_TexU;
  //! eNX`W V
  int m_TexV;
  //! eNX`W
  int m_TexW;
  //! eNX`Wc
  int m_TexH;
  //! ʏ Z]
  float m_RollZ;
  //! 3DW] X
  float m_RollX;
  //! 3DW] Y
  float m_RollY;
  //! Ƃ
  bool m_Flash;
  //! W̓XvCg̒Sۂ
  bool m_PosCenter;
  //! gpۂ(ړ炵Ȃ)
  bool m_Working;
  //! \邩ۂ(ړƂ͂)
  bool m_Visible;
  //! gpeNX`ԍ
  int  m_TextureID;

  /* ----------------------------------- */
  /* --- vCx[go */
 protected:

  /* ----------------------------------- */
  /* --- pubN\bh */
 public:
  //! Zq.
  PakoSpriteItem& operator=(const PakoSpriteItem& other);

  /* ----------------------------------- */
  /* --- vCx[g\bh */
 private:

};


#endif

