/* ---------------------------------------------------------- */
/*  ShootingObject.h                                          */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		蔻tXvCgNX
@author		K.Kunikane (rerofumi)
@since		Feb.14.2005
*/
/*-----------------------------------------------------
Copyright (C) 2005,2011 rero2@fumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------
Apr.10.2011 - PAKO game system ɘA
ʂ̃XvCg}l[Wւ
------------------------------------------------------*/

#ifndef SHOOTINGOBJECT_H
#define SHOOTINGOBJECT_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako/pako_spriteitem.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
* @brief V[eBOXvCgNX
*        蔻̃\bhXvCgACe
*        蔻
*
* @todo -
* @bug -
*/
class ShootingObject
{
	/* ----------------------------------- */
	/* --- RXgN^EfXgN^ */
public:
	ShootingObject(PakoSpriteItem *SpriteInstance);
	virtual  ~ShootingObject();

	/* ----------------------------------- */
	/* --- pubNo */
public:
	//! IuWFNg^Cv(ʂKvȎ)
	int  m_iType;
	//! 蔻L
	bool m_bGrazeEnable;
	//! 蔻L
	bool m_bHitEnable;
	//! `^蔻肩ǂ
	bool m_bSquareHit;
	//! XvCgACẽCX^X|C^
	PakoSpriteItem *m_pSprite;

	//! 蔻蔼a
	float  m_fHitR;
	//! 蔻苗vp
	float  m_fHitPow;
	//! 蔻蔼a
	float  m_fGrazeR;
	//! 蔻苗vp
	float  m_fGrazePow;
	//! `^qbg莞̏cTCY
	float  m_fHitRectW, m_fHitRectH;

protected:

	/* ----------------------------------- */
	/* --- vCx[go */
private:

	/* ----------------------------------- */
	/* --- pubN\bh */
public:
	void  SetHitSize(float r);
	void  SetHitSize(float w, float h);
	void  SetGrazeSize(float r);
	bool  CheckCollision(ShootingObject *obj);
	bool  CheckGraze(ShootingObject *obj);

	/* ----------------------------------- */
	/* --- vCx[g\bh */
private:
	bool checkCollisionRound(ShootingObject *obj);
	bool checkCollisionBox(ShootingObject *obj);

};


#endif

