/* ---------------------------------------------------------- */
/*  bulletmanage.h                                            */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		eȊO̓GIuWFNgǗ̃x[X
@author		K.Kunikane (rerofumi)
@since		Apr.17.2011
*/
/*-----------------------------------------------------
Copyright (C) 2011 rerofumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#ifndef ENEMYMANAGE_H
#define ENEMYMANAGE_H

#include <vector>

#include "pako/pako_opengl_app.h"
#include "enemyobject.h"
#include "bulletmaker.h"
#include "myshipmanage.h"


/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief GIuWFNg̐ƃCt^CǗ
 *        IuWFNg̔Əi
 *
 * @todo -
 * @bug -
 */
class EnemyManage
{
	/* ----------------------------------- */
	/* --- RXgN^EfXgN^ */
public:
	EnemyManage();
	virtual  ~EnemyManage();

	/* ----------------------------------- */
	/* --- pubNo */
public:

	/* ----------------------------------- */
	/* --- vCx[go */
private:
	//! AvP[VCX^X(XvCg}l[W瓾)
	PakoOpenglApp* m_pApp;
	//! Ge̔}l[W(IuWFNgɓnp)
	EnemyBulletMaker* m_pBulletMaker;
	//! @}l[W(IuWFNgɓnp)
	MyShipManage* m_pMyShip;
	//! ǗIuWFNg
	std::vector<EnemyObject*> m_vObject;
	//! VIuWFNg
	std::vector<EnemyObject*> m_vNewObject;
	//! XvCgC[
	int m_iSpliteLayerEnemy, m_iSpliteLayerWall;
	//! {XLꂽtO(1t[L)
	bool m_bDestroyBoss;
	//! ݃{XL\
	bool m_bAliveBoss;
	//! Xe[WɎc{XL̐
	int m_iBoss;

	/* ----------------------------------- */
	/* --- pubN\bh */
public:
	void  Init(PakoOpenglApp* pApp, EnemyBulletMaker *pBulletMaker, MyShipManage *pMyship, int enemy_splayer, int wall_splayer);
	bool  tick();
	bool  tickDisplay();

	void  AddEnemy(int chara, float x, float y);
	void  AddWall(int chara, float x, float y);

	int  CheckHit(ShootingObject* myshot);
	bool CheckMyshipHit(ShootingObject* myship);
	bool isDestroyBoss(void);
	bool isAliveBoss(void);

	/* ----------------------------------- */
	/* --- vCx[g\bh */
private:

};


#endif

