/**
 * PAKO state machine
 * Q[^Cg\
 */

#ifndef LS_STATE_TITLE_H
#define LS_STATE_TTILE_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako/pako_state_machine.h"


/*-------------------------------*/
/* define                        */
/*-------------------------------*/

static std::string LS_STATE_TITLE_NAME = "state::title";

static std::string LS_STATE_TITLE_SUB_FADEIN_NAME  = "state::title::in";
static std::string LS_STATE_TITLE_SUB_WAIT_NAME    = "state::title::wait";
static std::string LS_STATE_TITLE_SUB_FADEOUT_NAME = "state::title::out";

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * PstmTitle - PAKO state machine
 * ^CgʎsXe[g}V}l[W
 */
class PstmTitle : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmTitle)
    // v\bh
    virtual void tick();
    virtual void tickDisplay();
protected:
    virtual void onBegin(void);
    virtual void onEnd(void);
};


/* -------------------------------- */
/* --- sub state machine */

/* --- 1. ^CgʃtF[hC */
class PstmTitleSubIn : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmTitleSubIn)
    // v\bh
    virtual void tick();
    virtual void tickDisplay();
protected:
    virtual void onBegin(void);
    virtual void onEnd(void);
private:
    int m_iTimer;
};

/* --- 2. X^[g{^҂ */
class PstmTitleSubWait : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmTitleSubWait)
    // v\bh
    virtual void tick();
    virtual void tickDisplay();
protected:
    virtual void onBegin(void);
    virtual void onEnd(void);
private:
    int m_iTimer;
    bool m_bPush;
};

/* --- 3. ^CgʃtF[hAEg*/
class PstmTitleSubOut : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmTitleSubOut)
    // v\bh
    void tick();
    void tickDisplay();
protected:
    void onBegin(void);
    void onEnd(void);
private:
    int m_iTimer;
};

#endif
