/**
 * PAKO state machine
 * Q[CXe[g}l[W
 * ^CgʁAQ[{҂ƂAvP[V܂Ƃ߂
 */

#ifndef LS_STATE_TOP_H
#define LS_STATE_TOP_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako/pako_state_machine.h"


/*-------------------------------*/
/* define                        */
/*-------------------------------*/

static std::string LS_STATE_TOP_NAME = "state::top";

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * PstmTop - PAKO state machine
 * AvP[VCXe[g}V
 */
class PstmTop : public PakoStateMachine
{
public:
    CONSTRUCT_PAKO_STATE_MACHINE(PstmTop)
    // v\bh
    void tick();
    void tickDisplay();
protected:
    void onBegin(void);
    void onEnd(void);
};


#endif
