/* ---------------------------------------------------------- */
/*  myshipmanage.cpp                                          */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
@brief		@ǗNX
@author		K.Kunikane (끗ӂ)
@since		Feb.14.2005
*/
/*-----------------------------------------------------
Copyright (C) 2005,2011 rero2@fumi <rero2@yuumu.org>
All Rights Reserved.
------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include "myshipmanage.h"
#include "pako/pako_simple_app.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
* RXgN^
*/
MyShipManage::MyShipManage(PakoSpriteItem *SpriteInstance)
	: ShootingObject(SpriteInstance)
	, m_IsHit(false)
	, m_Wait(0)
	, m_Timer(0)
	, m_Bank(0)
{
	/* ---  */
	// m_ShotMan = null;
}


/**
* fXgN^(n)
*/
MyShipManage::~MyShipManage()
{
}



/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- SetMyShotMan() */
/**
* @e̊ǗCX^X󂯎
*
* @param shot [in] @ẽ}l[WCX^X
* @return 
*
*/
#if 0
void MyShipManage::SetMyShotMan(MyShotManage* shot)
{
	m_MyShotMan = shot;
}
#endif


/* ----------------------------------------- */
/* --- Init() */
/**
* 
* Q[JnɈ񂾂R[
*
* @return 
*
*/
void MyShipManage::Init(MyBulletMaker *pBulletMan)
{
	/* --- VbgNX̃CX^X */
	m_ShotMan = pBulletMan;

	/* --- IuWFNg̏ */
	m_pSprite->m_SizeW = 96;
	m_pSprite->m_SizeH = 86;
	m_pSprite->m_Blend = 1.0f;
	m_pSprite->m_Zoom = 1.0f;
	m_pSprite->m_TexU = 928;
	m_pSprite->m_TexV = 0;
	m_pSprite->m_TexW = 96;
	m_pSprite->m_TexH = 86;
	m_pSprite->m_PosCenter = true;
	m_pSprite->m_Working = true;
	m_pSprite->m_Visible = true;
    m_pSprite->m_TextureID = 0;

	/* --- 蔻 */
	SetHitSize(10.0);
	SetGrazeSize(12.0);
	m_bHitEnable = true;
	m_bGrazeEnable = true;
	m_fHitRectW = 9;
	m_fHitRectH = 9;

	/* --- ʒu */
	m_pSprite->m_PosX = 320;
	m_pSprite->m_PosY = 420;

	m_Timer = 0;
	m_IsHit = false;
	m_Wait = 0;
	m_Bank = 0;
}


/* ----------------------------------------- */
/* --- SetHitState() */
/**
* G̒eH炱炻̎|ĂĂ
*
* @param hit [in] eɂȂ true
* @return ߂ēȂ true (SEp̃^[)
*
*/
bool MyShipManage::SetHitState(bool hit)
{
	bool hitnow;

	hitnow = false;
	if (hit) {
		m_IsHit = hit;
		m_bHitEnable = false;
		/* -- e炢 SE p^[ */
		hitnow = true;
	}

	return(hitnow);
}


/* ----------------------------------------- */
/* --- GetHitState() */
/**
* G̒eH炢ς݂ǂ𓾂
*
* @return eHȂ true ʏԂ false
*
*/
bool MyShipManage::GetHitState()
{
	return(m_IsHit);
}


/* ----------------------------------------- */
/* --- tick() */
/**
*  @ړǗ
* t[R[
*
* @param inkey [in] vC[
* @return 
*
*/
bool MyShipManage::tick(unsigned long inkey,
	unsigned long inkey_triger)
{
	m_Timer += 1;

	/* --- qbgŃQ[I[o[܂ł̗]C */
	if (m_IsHit == true) {
		m_Wait += 1;
		crash_anime();
		if (m_Wait >= 45) {
			/* -- Q[I */
			return(false);
		}
		/* -- ƃEFCg */
		return(true);
	}

	/* --- o꒼͖G */
	if (m_Timer < 120) {
		m_bHitEnable = false;
		m_pSprite->m_Visible = ((m_Timer % 8) > 4);
	}
	if (m_Timer == 120) {
		m_bHitEnable = true;
		m_pSprite->m_Visible = true;
	}

	/* --- ړ */
	{
		bool onX = false;
		bool onY = false;
		float moveX = 0.0f;
		float moveY = 0.0f;

		if (((inkey & PakoSimpleApp::Input::IN_Left) > 0) &&
			((inkey & PakoSimpleApp::Input::IN_Right) > 0)) {
				/* -- ͖ɂ */
				/* ̃R}΍(R) */
				m_Bank = 0;
		}
		else if(inkey & PakoSimpleApp::Input::IN_Left) {
			/* -- ړ */
			if (m_pSprite->m_PosX > 24.0f) {
				onX = true;
				moveX = -4.0f;
			}
		}
		else if(inkey & PakoSimpleApp::Input::IN_Right) {
			/* -- Eړ */
			if (m_pSprite->m_PosX < (640.0f - 24.0f)) {
				onX = true;
				moveX = 4.0f;
			}
		}

		if (((inkey & PakoSimpleApp::Input::IN_Up) > 0) &&
			((inkey & PakoSimpleApp::Input::IN_Down) > 0)) {
				/* -- ͖ɂ */
				/* ̃R}΍(R) */
				m_Bank = 0;
		}
		else if(inkey & PakoSimpleApp::Input::IN_Up) {
			/* -- ړ */
			if (m_pSprite->m_PosY > 48.0f) {
				onY = true;
				moveY = -4.0f;
			}
		}
		else if(inkey & PakoSimpleApp::Input::IN_Down) {
			/* -- ړ */
			if (m_pSprite->m_PosY < (480.0f - 32.0f)) {
				onY = true;
				moveY = 4.0f;
			}
		}

		if ((onX == true) && (onY == true)) {
			moveX *= 0.7071f;
			moveY *= 0.7071f;
		}
		m_pSprite->m_PosX += moveX;
		m_pSprite->m_PosY += moveY;
	}

	/* --- Vbg */
	if (inkey_triger & (PakoSimpleApp::Input::IN_Button1 | PakoSimpleApp::Input::IN_Button2)) {
		/* -- Vbg */
		m_ShotMan->doShot(m_Level, m_pSprite->m_PosX, m_pSprite->m_PosY);
	}

	return(true);
}


/* ----------------------------------------- */
/* --- tickDisplay() */
/**
*  @ړǗ
* t[R[
*
* @param inkey [in] vC[
* @return 
*/
bool MyShipManage::tickDisplay(void)
{
	return(true);
}



/*------------------------------------------------------*/
/* local work                                           */
/*------------------------------------------------------*/

void MyShipManage::crash_anime()
{
	if (m_Wait < 8) {
		m_pSprite->m_SizeW = 256;
		m_pSprite->m_SizeH = 96;
		m_pSprite->m_TexU = 736;
		m_pSprite->m_TexV = 160;
		m_pSprite->m_TexW = 256;
		m_pSprite->m_TexH = 96;
	}
	else if (m_Wait < 16) {
		m_pSprite->m_SizeW = 256;
		m_pSprite->m_SizeH = 96;
		m_pSprite->m_TexU = 736;
		m_pSprite->m_TexV = 256;
		m_pSprite->m_TexW = 256;
		m_pSprite->m_TexH = 96;
	}
	else if (m_Wait < 24) {
		m_pSprite->m_SizeW = 256;
		m_pSprite->m_SizeH = 96;
		m_pSprite->m_TexU = 736;
		m_pSprite->m_TexV = 352;
		m_pSprite->m_TexW = 256;
		m_pSprite->m_TexH = 96;
	}
	else {
		m_pSprite->m_Visible = false;
	}
}
