/* ---------------------------------------------------------- */
/*  pako_es_opengl_app.h                                         */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - OpenGLES application class
    @author   rerofumi
    @since    Nov.05.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef PAKO_ES_OPENGL_APP_H
#define PAKO_ES_OPENGL_APP_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include <GL/gl.h>
#include <GLES/egl.h>

#include "pako_simple_app.h"
#include "pako_math.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief SDL-Opengl Q[AvP[VNX
 *        PCł Opengl \NX
 *
 * @todo -
 * @bug -
 */
class PakoEsOpenglApp : public PakoSimpleApp
{
  /* ----------------------------------- */
  /* --- RXgN^EfXgN^ */
 public:
  PakoEsOpenglApp();
  virtual  ~PakoEsOpenglApp();

  /* ----------------------------------- */
  /* --- pubNo */
 public:

  /* ----------------------------------- */
  /* --- thNXo */
 protected:

  /* ----------------------------------- */
  /* --- vCx[go */
 private:
  EGLDisplay dpy;
  EGLContext ctx;
  EGLSurface surface;
  EGLint width;
  EGLint height;

  /* ----------------------------------- */
  /* --- pubN\bh */
 public:

  /* ----------------------------------- */
  /* --- thNX\bh */
 protected:
  int onBoot(void);
  int onShutdown(void);
  void swapFrameBuffer(void);

  /* ----------------------------------- */
  /* --- vCx[g\bh */
 private:

};


#endif

